#include "CMcl.h"

class CSingleAdmissionGate {
private:
    BOOL m_bIsEntered;
    CMclCritSec m_CritSec;

public:
    CSingleAdmissionGate() {
        m_bIsEntered = FALSE;
    };

    BOOL Try() {
        m_CritSec.Enter();
        if (m_bIsEntered == TRUE) {
            m_CritSec.Leave();
            return FALSE;

        }
        else {
            m_bIsEntered = TRUE;
            m_CritSec.Leave();
            return TRUE;
        }
    };

    void Leave() {
        m_CritSec.Enter();
        m_bIsEntered = FALSE;
        m_CritSec.Leave();
    };
};
